procedure TControlForm.BImportG2DClick(Sender: TObject);
var G2D:TINIFile; i,Index:integer; SecName:string;
begin
  if not DOpenG2D.Execute then exit;
  try
    G2D:=TINIFile.Create(DOpenG2D.FileName);
  except
    MessageDlg('Kann Eingabedatei '+DOpenG2D.FileName+' nicht ffnen!',mtError,[mbOK],0);
    exit;
  end;
  if G2D.ReadInteger('Graph2D','FormatVersion',0)<>1 then begin
    MessageDlg('Ungltige Datei oder falsche Dateiversion!',mtError,[mbOK],0);
    exit;
  end;

  for i:=0 to High(Functions) do Functions[i].Used:=false;
  FunctionsBox.Items.Clear;
  ActiveFunction:=-1;
  PSUIForm.ExportValues;

  with G2D do begin
    GraphForm.ClientWidth:=ReadInteger('Graph2D','GraphWindowWidth',GraphForm.ClientWidth);
    GraphForm.ClientHeight:=ReadInteger('Graph2D','GraphWindowHeight',GraphForm.ClientHeight);
    // [Display]
    DrawAxes:=ReadBool('Display','DrawAxes',DrawAxes);
    DrawGrid:=ReadBool('Display','DrawGrid',DrawGrid);
    DrawScale:=ReadBool('Display','DrawScale',DrawScale);
    AxeColor:=DecodeColor(Trim(ReadString('Display','AxeColor','')),AxeColor);
    GridColor:=DecodeColor(Trim(ReadString('Display','GridColor','')),GridColor);
    ForegroundScale:=ReadBool('Display','ForegroundScale',ForegroundScale);
    SetupChange(nil);
    // [ViewRange]
    CenterX:=ReadFloat('ViewRange','CenterX',CenterX);
    CenterY:=ReadFloat('ViewRange','CenterY',CenterY);
    ScaleX:=ReadFloat('ViewRange','ScaleX',ScaleX);
    ScaleY:=ReadFloat('ViewRange','ScaleY',ScaleY);
    StepX:=ReadFloat('ViewRange','StepX',StepX);
    StepY:=ReadFloat('ViewRange','StepY',StepY);
    AutoGrid:=ReadBool('ViewRange','AutoGrid',AutoGrid);
    ParamStart:=ReadFloat('ViewRange','ParamStart',ParamStart);
    ParamEnd:=ReadFloat('ViewRange','ParamEnd',ParamEnd);
    ParamStep:=ReadFloat('ViewRange','ParamStep',ParamStep);
    ControlForm.ETRangeStart.Text:=FloatToStr(ParamStart);
    ControlForm.ETRangeEnd.Text:=FloatToStr(ParamEnd);
    ControlForm.ETRangeStep.Text:=FloatToStr(ParamStep);
    // [PostScript]
    DrawClipBox:=ReadBool('PostScript','DrawClipBox',DrawClipBox);
    FunctionLineWidth:=ReadFloat('PostScript','FunctionLineWidth',FunctionLineWidth);
    ClipBoxLineWidth:=ReadFloat('PostScript','ClipBoxLineWidth',ClipBoxLineWidth);
    AxeLineWidth:=ReadFloat('PostScript','AxeLineWidth',AxeLineWidth);
    GridLineWidth:=ReadFloat('PostScript','GridLineWidth',GridLineWidth);
    TickLineWidth:=ReadFloat('PostScript','TickLineWidth',TickLineWidth);
    NumberFontSize:=ReadFloat('PostScript','NumberFontSize',NumberFontSize);
    PageSizeX:=ReadInteger('PostScript','PageSizeX',PageSizeX);
    PageSizeY:=ReadInteger('PostScript','PageSizeY',PageSizeY);
    PageMargin:=ReadInteger('PostScript','PageMargin',PageMargin);
    UnitName:=ReadString('PostScript','Unit',UnitName);
    // [Function*]
    i:=0; SecName:='Function1';
    while SectionExists(SecName) do begin
      Index:=CreateNewFunction;
      FunctionsBox.Items.Add(IntToStr(Index));
      with Functions[Index] do begin
        if ReadBool(SecName,'ActiveFunction',false) then ActiveFunction:=Index;
        Active:=ReadBool(SecName,'Active',Active);
        Parametric:=ReadBool(SecName,'Parametric',Parametric);
        if not Parametric then begin
          Expression:=ReadString(SecName,'Expression',Expression);
          Error:=ParseFunction(Expression,Tree);
          DestroyExpressionTree(Tree2);
        end else begin
          Expression:=ReadString(SecName,'ExpressionX',Expression);
          Expression2:=ReadString(SecName,'ExpressionY',Expression2);
          Error:=ParseFunction(Expression,Tree);
          if Error then DestroyExpressionTree(Tree2)
                   else Error:=ParseFunction(Expression2,Tree2);
        end;
        Multi:=ReadBool(SecName,'Multi',Multi);
        MultiStart:=ReadFloat(SecName,'MultiStart',MultiStart);
        MultiEnd:=ReadFloat(SecName,'MultiEnd',MultiEnd);
        MultiStep:=ReadFloat(SecName,'MultiStep',MultiStep);
        Color:=DecodeColor(Trim(ReadString(SecName,'Color','')),Color);
        Gradient:=ReadBool(SecName,'Gradient',Gradient);
        Color2:=DecodeColor(Trim(ReadString(SecName,'Color2','')),Color2);
        Derive:=ReadBool(SecName,'Derive',Derive);
      end;
      inc(i); SecName:='Function'+IntToStr(i+1);
    end;
    Free;
  end;
  if ActiveFunction>=0 then FunctionToForm(ActiveFunction);
  fnChanged:=false;
  FunctionsBox.Invalidate;
  GraphForm.RangeChange;
  PSUIForm.ImportValues;
end;

